Index: trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.Designer.cs	(revision 3890)
+++ trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.Designer.cs	(revision 3890)
@@ -0,0 +1,132 @@
+﻿namespace HeuristicLab.Problems.ExternalEvaluation.Views {
+  partial class EvaluationTCPChannelView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.ipAddressLabel = new System.Windows.Forms.Label();
+      this.portLabel = new System.Windows.Forms.Label();
+      this.ipAddressTextBox = new System.Windows.Forms.TextBox();
+      this.portTextBox = new System.Windows.Forms.TextBox();
+      this.connectButton = new System.Windows.Forms.Button();
+      this.disconnectButton = new System.Windows.Forms.Button();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      // 
+      // ipAddressLabel
+      // 
+      this.ipAddressLabel.AutoSize = true;
+      this.ipAddressLabel.Location = new System.Drawing.Point(3, 61);
+      this.ipAddressLabel.Name = "ipAddressLabel";
+      this.ipAddressLabel.Size = new System.Drawing.Size(61, 13);
+      this.ipAddressLabel.TabIndex = 4;
+      this.ipAddressLabel.Text = "IP Address:";
+      // 
+      // portLabel
+      // 
+      this.portLabel.AutoSize = true;
+      this.portLabel.Location = new System.Drawing.Point(3, 87);
+      this.portLabel.Name = "portLabel";
+      this.portLabel.Size = new System.Drawing.Size(29, 13);
+      this.portLabel.TabIndex = 5;
+      this.portLabel.Text = "Port:";
+      // 
+      // ipAddressTextBox
+      // 
+      this.ipAddressTextBox.Location = new System.Drawing.Point(72, 58);
+      this.ipAddressTextBox.Name = "ipAddressTextBox";
+      this.ipAddressTextBox.Size = new System.Drawing.Size(100, 20);
+      this.ipAddressTextBox.TabIndex = 6;
+      this.ipAddressTextBox.Text = "127.0.0.1";
+      this.ipAddressTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.ipAddressTextBox_Validating);
+      // 
+      // portTextBox
+      // 
+      this.portTextBox.Location = new System.Drawing.Point(72, 84);
+      this.portTextBox.Name = "portTextBox";
+      this.portTextBox.Size = new System.Drawing.Size(100, 20);
+      this.portTextBox.TabIndex = 7;
+      this.portTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.portTextBox_Validating);
+      // 
+      // connectButton
+      // 
+      this.connectButton.Location = new System.Drawing.Point(6, 110);
+      this.connectButton.Name = "connectButton";
+      this.connectButton.Size = new System.Drawing.Size(75, 23);
+      this.connectButton.TabIndex = 8;
+      this.connectButton.Text = "Connect";
+      this.connectButton.UseVisualStyleBackColor = true;
+      this.connectButton.Click += new System.EventHandler(this.connectButton_Click);
+      // 
+      // disconnectButton
+      // 
+      this.disconnectButton.Location = new System.Drawing.Point(97, 110);
+      this.disconnectButton.Name = "disconnectButton";
+      this.disconnectButton.Size = new System.Drawing.Size(75, 23);
+      this.disconnectButton.TabIndex = 9;
+      this.disconnectButton.Text = "Disconnect";
+      this.disconnectButton.UseVisualStyleBackColor = true;
+      this.disconnectButton.Click += new System.EventHandler(this.disconnectButton_Click);
+      // 
+      // EvaluationTCPChannelView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.ipAddressLabel);
+      this.Controls.Add(this.ipAddressTextBox);
+      this.Controls.Add(this.portTextBox);
+      this.Controls.Add(this.portLabel);
+      this.Controls.Add(this.connectButton);
+      this.Controls.Add(this.disconnectButton);
+      this.Name = "EvaluationTCPChannelView";
+      this.Size = new System.Drawing.Size(351, 139);
+      this.Controls.SetChildIndex(this.disconnectButton, 0);
+      this.Controls.SetChildIndex(this.connectButton, 0);
+      this.Controls.SetChildIndex(this.portLabel, 0);
+      this.Controls.SetChildIndex(this.portTextBox, 0);
+      this.Controls.SetChildIndex(this.ipAddressTextBox, 0);
+      this.Controls.SetChildIndex(this.ipAddressLabel, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.descriptionLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label ipAddressLabel;
+    private System.Windows.Forms.Label portLabel;
+    private System.Windows.Forms.TextBox ipAddressTextBox;
+    private System.Windows.Forms.TextBox portTextBox;
+    private System.Windows.Forms.Button connectButton;
+    private System.Windows.Forms.Button disconnectButton;
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.cs	(revision 3890)
+++ trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.cs	(revision 3890)
@@ -0,0 +1,136 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.Core.Views;
+
+namespace HeuristicLab.Problems.ExternalEvaluation.Views {
+  [View("TCP Channel View")]
+  [Content(typeof(EvaluationTCPChannel), IsDefaultView = true)]
+  public sealed partial class EvaluationTCPChannelView : NamedItemView {
+    public new EvaluationTCPChannel Content {
+      get { return (EvaluationTCPChannel)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public EvaluationTCPChannelView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.Connected -= new EventHandler(Content_Connected);
+      Content.Disconnected -= new EventHandler(Content_Disconnected);
+      Content.IpAddressChanged -= new EventHandler(Content_IpAddressChanged);
+      Content.PortChanged -= new EventHandler(Content_PortChanged);
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.Connected += new EventHandler(Content_Connected);
+      Content.Disconnected += new EventHandler(Content_Disconnected);
+      Content.IpAddressChanged += new EventHandler(Content_IpAddressChanged);
+      Content.PortChanged += new EventHandler(Content_PortChanged);
+    }
+
+    #region Event Handlers (Content)
+    private void Content_Connected(object sender, EventArgs e) {
+      SetEnabledStateOfControls();
+    }
+    private void Content_Disconnected(object sender, EventArgs e) {
+      SetEnabledStateOfControls();
+    }
+    private void Content_IpAddressChanged(object sender, EventArgs e) {
+      ipAddressTextBox.Text = Content.IpAddress;
+    }
+    private void Content_PortChanged(object sender, EventArgs e) {
+      portTextBox.Text = Content.Port.ToString();
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        ipAddressTextBox.Text = String.Empty;
+        portTextBox.Text = String.Empty;
+      } else {
+        ipAddressTextBox.Text = Content.IpAddress;
+        portTextBox.Text = Content.Port.ToString();
+      }
+      SetEnabledStateOfControls();
+    }
+
+    protected override void OnReadOnlyChanged() {
+      base.OnReadOnlyChanged();
+      SetEnabledStateOfControls();
+    }
+
+    private void SetEnabledStateOfControls() {
+      bool readOnlyDriverNullOrStarted = ReadOnly || Content == null || Content.IsInitialized;
+      ipAddressTextBox.Enabled = !readOnlyDriverNullOrStarted;
+      portTextBox.Enabled = !readOnlyDriverNullOrStarted;
+      connectButton.Enabled = !readOnlyDriverNullOrStarted;
+      disconnectButton.Enabled = !ReadOnly && Content != null && Content.IsInitialized;
+    }
+
+    #region Event Handlers (child controls)
+    private void ipAddressTextBox_Validating(object sender, CancelEventArgs e) {
+      if (Content != null) {
+        try {
+          System.Net.IPAddress.Parse(ipAddressTextBox.Text);
+        } catch (FormatException) {
+          e.Cancel = true;
+        }
+        if (!e.Cancel) Content.IpAddress = ipAddressTextBox.Text;
+      }
+    }
+    private void portTextBox_Validating(object sender, CancelEventArgs e) {
+      if (Content != null) {
+        int port;
+        e.Cancel = !int.TryParse(portTextBox.Text, out port);
+        if (!e.Cancel) Content.Port = port;
+      }
+    }
+    private void connectButton_Click(object sender, EventArgs e) {
+      try {
+        Content.Open();
+      } catch (Exception ex) {
+        MessageBox.Show(ex.Message);
+      }
+    }
+    private void disconnectButton_Click(object sender, EventArgs e) {
+      try {
+        Content.Close();
+      } catch (Exception ex) {
+        MessageBox.Show(ex.Message);
+      }
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.resx
===================================================================
--- trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.resx	(revision 3890)
+++ trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/EvaluationTCPChannelView.resx	(revision 3890)
@@ -0,0 +1,129 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>107, 17</value>
+  </metadata>
+  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>107, 17</value>
+  </metadata>
+  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
+</root>
Index: trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/HeuristicLab.Problems.ExternalEvaluation.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/HeuristicLab.Problems.ExternalEvaluation.Views-3.3.csproj	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.ExternalEvaluation.Views/3.3/HeuristicLab.Problems.ExternalEvaluation.Views-3.3.csproj	(revision 3890)
@@ -95,4 +95,10 @@
       <DependentUpon>EvaluationProcessChannelView.cs</DependentUpon>
     </Compile>
+    <Compile Include="EvaluationTCPChannelView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="EvaluationTCPChannelView.Designer.cs">
+      <DependentUpon>EvaluationTCPChannelView.cs</DependentUpon>
+    </Compile>
     <Compile Include="HeuristicLabProblemsExternalEvaluationViewsPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -148,4 +154,7 @@
       <DependentUpon>EvaluationServiceClientView.cs</DependentUpon>
     </EmbeddedResource>
+    <EmbeddedResource Include="EvaluationTCPChannelView.resx">
+      <DependentUpon>EvaluationTCPChannelView.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="SolutionMessageBuilderView.resx">
       <DependentUpon>SolutionMessageBuilderView.cs</DependentUpon>