Index: trunk/sources/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationCD.cd
===================================================================
--- trunk/sources/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationCD.cd	(revision 3897)
+++ trunk/sources/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationCD.cd	(revision 3897)
@@ -0,0 +1,209 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<ClassDiagram MajorVersion="1" MinorVersion="1">
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.BoolConverter" BaseTypeListCollapsed="true">
+    <Position X="0.5" Y="9.75" Width="1.5" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABACAAAAAgA=</HashCode>
+      <FileName>Converters\BoolConverter.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.DateTimeValueConverter" BaseTypeListCollapsed="true">
+    <Position X="2.25" Y="9.75" Width="1.5" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABACAAAAAgA=</HashCode>
+      <FileName>Converters\DateTimeValueConverter.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.DoubleConverter" BaseTypeListCollapsed="true">
+    <Position X="4" Y="9.75" Width="1.5" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABACAAAAAgA=</HashCode>
+      <FileName>Converters\DoubleConverter.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.IntegerConverter" BaseTypeListCollapsed="true">
+    <Position X="4" Y="12" Width="1.5" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABACAAAAAgA=</HashCode>
+      <FileName>Converters\IntegerConverter.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.StringConverter" BaseTypeListCollapsed="true">
+    <Position X="2.25" Y="12" Width="1.5" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABACAAAAAgA=</HashCode>
+      <FileName>Converters\StringConverter.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.TimeSpanValueConverter" BaseTypeListCollapsed="true">
+    <Position X="0.5" Y="12" Width="1.5" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABACAAAAAgA=</HashCode>
+      <FileName>Converters\TimeSpanValueConverter.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.EvaluationChannel" Collapsed="true">
+    <Position X="3" Y="0.5" Width="1.5" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAIAAAAEAAAAAAAAAAgAAQAAAABACABAA=</HashCode>
+      <FileName>Drivers\EvaluationChannel.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.EvaluationProcessChannel">
+    <Position X="2.75" Y="3.5" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>BAAAAAAAAAAAIAAAAEEgAgIAgAIgIgAQIAAAAACAEBg=</HashCode>
+      <FileName>Drivers\EvaluationProcessChannel.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.EvaluationServiceClient" BaseTypeListCollapsed="true">
+    <Position X="0.5" Y="14.5" Width="2" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAhAAAAAACAAAQAAgAAAAAAgAAAAhAAAAAABAA=</HashCode>
+      <FileName>Drivers\EvaluationServiceClient.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.EvaluationStreamChannel">
+    <Position X="5" Y="3.5" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAEAAAAAACAAAABAQAAAAAACAAAA=</HashCode>
+      <FileName>Drivers\EvaluationStreamChannel.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.EvaluationTCPChannel">
+    <Position X="0.5" Y="3.5" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAAAAAAQCAAQcIAEAGCAAAAAaCgAAAoQAQEAAgCAABA=</HashCode>
+      <FileName>Drivers\EvaluationTCPChannel.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.ExternalEvaluationProblem" BaseTypeListCollapsed="true">
+    <Position X="0.5" Y="18.25" Width="2.25" />
+    <TypeIdentifier>
+      <HashCode>AAARAACGAwgABbAGCJCAQIEMAAGKAAAACIQAESAgpVA=</HashCode>
+      <FileName>ExternalEvaluationProblem.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.ExternalEvaluator" BaseTypeListCollapsed="true">
+    <Position X="5.75" Y="14.5" Width="1.5" />
+    <TypeIdentifier>
+      <HashCode>AAAQAAAgABAAAAAAAAAAAAAAAAAAAAEAAAAAAAgAAAA=</HashCode>
+      <FileName>ExternalEvaluator.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" Collapsed="true" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.SolutionMessage">
+    <Position X="5.25" Y="18.25" Width="2.25" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <NestedTypes>
+      <Class Name="HeuristicLab.Problems.ExternalEvaluation.SolutionMessage.Types" Collapsed="true">
+        <TypeIdentifier>
+          <NewMemberFileName>Protos\ExternalEvaluationMessages.cs</NewMemberFileName>
+        </TypeIdentifier>
+      </Class>
+      <Class Name="HeuristicLab.Problems.ExternalEvaluation.SolutionMessage.Builder" Collapsed="true">
+        <TypeIdentifier>
+          <NewMemberFileName>Protos\ExternalEvaluationMessages.cs</NewMemberFileName>
+        </TypeIdentifier>
+      </Class>
+    </NestedTypes>
+    <TypeIdentifier>
+      <HashCode>XGEAApEgkUOSJEQREEkgQAFBQRQHASKyAQ0CDCQAoAA=</HashCode>
+      <FileName>Protos\ExternalEvaluationMessages.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.QualityMessage">
+    <Position X="3" Y="18.25" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <NestedTypes>
+      <Class Name="HeuristicLab.Problems.ExternalEvaluation.QualityMessage.Builder" Collapsed="true">
+        <TypeIdentifier>
+          <NewMemberFileName>Protos\ExternalEvaluationMessages.cs</NewMemberFileName>
+        </TypeIdentifier>
+      </Class>
+    </NestedTypes>
+    <TypeIdentifier>
+      <HashCode>VGAAgAAgAMEAIABAAAggAAEAAIABAgIwAAgADAAAgAA=</HashCode>
+      <FileName>Protos\ExternalEvaluationMessages.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.Problems.ExternalEvaluation.SolutionMessageBuilder">
+    <Position X="5.75" Y="9.75" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AASAAAACAAAAAAAAIAAAAMAkAAAAgRAAAAAAAAAAhAA=</HashCode>
+      <FileName>SolutionMessageBuilder.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Interface Name="HeuristicLab.Problems.ExternalEvaluation.IEvaluationChannel">
+    <Position X="0.5" Y="0.5" Width="1.75" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAIAAAAEAAAAAAAAAAAAAQAAAABACAAAA=</HashCode>
+      <FileName>Interfaces\IEvaluationChannel.cs</FileName>
+    </TypeIdentifier>
+  </Interface>
+  <Interface Name="HeuristicLab.Problems.ExternalEvaluation.IEvaluationServiceClient">
+    <Position X="3" Y="14.5" Width="2" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAQAAgAAAAAAAAAAAAAAAAAAAAA=</HashCode>
+      <FileName>Interfaces\IEvaluationServiceClient.cs</FileName>
+    </TypeIdentifier>
+  </Interface>
+  <Interface Name="HeuristicLab.Problems.ExternalEvaluation.IExternalEvaluationProblemEvaluator">
+    <Position X="2.75" Y="16.25" Width="2.75" />
+    <TypeIdentifier>
+      <HashCode>AAAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
+      <FileName>Interfaces\IExternalEvaluationProblemEvaluator.cs</FileName>
+    </TypeIdentifier>
+  </Interface>
+  <Interface Name="HeuristicLab.Problems.ExternalEvaluation.IItemToSolutionMessageConverter">
+    <Position X="5.25" Y="7.5" Width="2.5" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABAAAAAAAgA=</HashCode>
+      <FileName>Interfaces\IItemToSolutionMessageConverter.cs</FileName>
+    </TypeIdentifier>
+  </Interface>
+  <Font Name="Segoe UI" Size="9" />
+</ClassDiagram>